#include <stdio.h>

int min[10001];
int N;
int value[500], weight[500];

int calcmin(int w)
{  
   int i, ll, lmin;
   
   if (w<0) return -1;
   if (min[w] >= 0) return min[w];
   else {
     lmin = -1;
     for(i=0; i<N; i++) {
       ll = calcmin(w - weight[i]);
       if (ll >= 0) {
         ll += value[i];
	 if ((ll < lmin) || (lmin == -1)) lmin = ll;
       }
     }
     return min[w] = lmin;
   }
}

int main(void) 
{
  int E, F, T;
  int i, minw;
  
  scanf("%d", &T);
  while ((T--) > 0) {
    min[0] = 0;
    for(i=1; i<=10000; i++) min[i] = -1;
    
    scanf("%d%d", &E, &F);
    
    scanf("%d", &N);    
    for(i=0; i<N; i++) scanf("%d%d", &value[i], &weight[i]);
    
    minw = calcmin(F - E);
    if (minw >= 0) printf("The minimum amount of money in the piggy-bank is %d.\n",  minw);
    else printf("This is impossible.\n");
  }
  return 0;
}