#include <stdio.h>

int R, C, D, W, maxx;
int row;
int pos[1001], was[1001];
char key[100][101];
char lock[10000][1001];  /* y,x */

int okpos(int x, int y) 
{
  int xx, yy, ly;
  
  for(yy=0; yy < R; yy++) {
    ly = y + yy;
    if ((ly < 0) || (ly >= D)) continue;
    for(xx = 0; xx < C; xx++) {
      if ((key[yy][xx] == '#') && (lock[ly][x+xx] == '#')) return 0;
    }
  }       
  return 1;
}

int eval(void)
{
  int xx, cnt;
  
  cnt = 0;
  for(xx = 0; xx<=maxx; xx++) {
    if (pos[xx] == -1) {
      if (okpos(xx, row)) { pos[xx] = 1; cnt++; } 
      else pos[xx] = 0;
    } else if (pos[xx] == 1) cnt++;
  }
  
  return cnt;
}

int main(void)
{
  int T;
  int xx, y, cnt, npos, last;
  
  scanf("%d", &T);
  while (T--) {
    scanf("%d%d", &R, &C);
    for(y=0; y<R; y++)
      scanf("%s", key[R-1-y]);
    
    scanf("%d%d", &D, &W);  maxx = W - C;
    for(y=0; y<D; y++)
      scanf("%s", lock[D-1-y]);

    row = D - 1;
    for(xx=0; xx<=maxx; xx++) pos[xx] = -1; 
    
    while (row > -R) {
      for(xx=0; xx<=maxx; xx++) was[xx] = 0;     
      
      do {
        cnt = 0;
	npos = eval();
	if (npos <= 0) break;
	
	if (row != D - 1) {
	  last = -1;
	  for(xx=0; xx<=maxx; xx++) {
	  
	    if ((pos[xx] == 0) && (last == 1)) {
	      if (was[xx]==0) {
	        pos[xx] = -1;  cnt++;
                last = 0;
		was[xx] = 1;
	      } else last = pos[xx];
	      
	    } else
	    
	    if ((last == 0) && (pos[xx] == 1)) {
	      if (was[xx]==0) {	    
	        pos[xx-1] = -1;
                last = pos[xx];  cnt++;
		was[xx] = 1;
	      } else last = pos[xx];		
	      
	    } else last = pos[xx];
	  }
	}
	
      } while (cnt > 0);
      
      if (npos == 0) break;
      row--;
      for(xx=0; xx<=maxx; xx++) pos[xx] = -pos[xx];
    }
    
    if (row <= -R) printf("The key can fall through.\n");
    else printf("The key falls to depth %d.\n", D - 1 - row);
  }
  
  return 0;
}